OpenCV: cv::cuda::GpuMat Class Reference

| OpenCV 3.4.2 Open Source Computer Vision

Classes | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
cv::cuda::GpuMat Class Reference
Core functionality » OpenGL interoperability » CUDA-accelerated Computer Vision » Core part » Data Structures

Base storage class for GPU memory with reference counting. More...

`#include "cuda.hpp"`

Inheritance diagram for cv::cuda::GpuMat:

## Classes
class | Allocator

## Public Member Functions
| GpuMat (Allocator *allocator=defaultAllocator())
| default constructor More...
| GpuMat (int rows, int cols, int type, Allocator *allocator=defaultAllocator())
| constructs GpuMat of the specified size and type More...
| GpuMat (Size size, int type, Allocator *allocator=defaultAllocator())
| GpuMat (int rows, int cols, int type, Scalar s, Allocator *allocator=defaultAllocator())
| constucts GpuMat and fills it with the specified value _s More...
| GpuMat (Size size, int type, Scalar s, Allocator *allocator=defaultAllocator())
| GpuMat (const GpuMat &m)
| copy constructor More...
| GpuMat (int rows, int cols, int type, void *data, size_t step=Mat::AUTO_STEP)
| constructor for GpuMat headers pointing to user-allocated data More...
| GpuMat (Size size, int type, void *data, size_t step=Mat::AUTO_STEP)
| GpuMat (const GpuMat &m, Range rowRange, Range colRange)
| creates a GpuMat header for a part of the bigger matrix More...
| GpuMat (const GpuMat &m, Rect roi)
| GpuMat (InputArray arr, Allocator *allocator=defaultAllocator())
| builds GpuMat from host memory (Blocking call) More...
| ~GpuMat ()
| destructor - calls release() More...
GpuMat & | adjustROI (int dtop, int dbottom, int dleft, int dright)
| moves/resizes the current GpuMat ROI inside the parent GpuMat More...
void | assignTo (GpuMat &m, int type=-1) const
int | channels () const
| returns number of channels More...
GpuMat | clone () const
| returns deep copy of the GpuMat, i.e. the data is copied More...
GpuMat | col (int x) const
| returns a new GpuMat header for the specified column More...
GpuMat | colRange (int startcol, int endcol) const
| ... for the specified column span More...
GpuMat | colRange (Range r) const
void | convertTo (OutputArray dst, int rtype) const
| converts GpuMat to another datatype (Blocking call) More...
void | convertTo (OutputArray dst, int rtype, Stream &stream) const
| converts GpuMat to another datatype (Non-Blocking call) More...
void | convertTo (OutputArray dst, int rtype, double alpha, double beta=0.0) const
| converts GpuMat to another datatype with scaling (Blocking call) More...
void | convertTo (OutputArray dst, int rtype, double alpha, Stream &stream) const
| converts GpuMat to another datatype with scaling (Non-Blocking call) More...
void | convertTo (OutputArray dst, int rtype, double alpha, double beta, Stream &stream) const
| converts GpuMat to another datatype with scaling (Non-Blocking call) More...
void | copyTo (OutputArray dst) const
| copies the GpuMat content to device memory (Blocking call) More...
void | copyTo (OutputArray dst, Stream &stream) const
| copies the GpuMat content to device memory (Non-Blocking call) More...
void | copyTo (OutputArray dst, InputArray mask) const
| copies those GpuMat elements to "m" that are marked with non-zero mask elements (Blocking call) More...
void | copyTo (OutputArray dst, InputArray mask, Stream &stream) const
| copies those GpuMat elements to "m" that are marked with non-zero mask elements (Non-Blocking call) More...
void | create (int rows, int cols, int type)
| allocates new GpuMat data unless the GpuMat already has specified size and type More...
void | create (Size size, int type)
int | depth () const
| returns element type More...
void | download (OutputArray dst) const
| Performs data download from GpuMat (Blocking call) More...
void | download (OutputArray dst, Stream &stream) const
| Performs data download from GpuMat (Non-Blocking call) More...
size_t | elemSize () const
| returns element size in bytes More...
size_t | elemSize1 () const
| returns the size of element channel in bytes More...
bool | empty () const
| returns true if GpuMat data is NULL More...
bool | isContinuous () const
void | locateROI (Size &wholeSize, Point &ofs) const
| locates GpuMat header within a parent GpuMat More...
template<typename _Tp >
| operator PtrStep< _Tp > () const
template<typename _Tp >
| operator PtrStepSz< _Tp > () const
GpuMat | operator() (Range rowRange, Range colRange) const
| extracts a rectangular sub-GpuMat (this is a generalized form of row, rowRange etc.) More...
GpuMat | operator() (Rect roi) const
GpuMat & | operator= (const GpuMat &m)
| assignment operators More...
uchar * | ptr (int y=0)
| returns pointer to y-th row More...
const uchar * | ptr (int y=0) const
template<typename _Tp >
_Tp * | ptr (int y=0)
| template version of the above method More...
template<typename _Tp >
const _Tp * | ptr (int y=0) const
void | release ()
| decreases reference counter, deallocate the data when reference counter reaches 0 More...
GpuMat | reshape (int cn, int rows=0) const
GpuMat | row (int y) const
| returns a new GpuMat header for the specified row More...
GpuMat | rowRange (int startrow, int endrow) const
| ... for the specified row span More...
GpuMat | rowRange (Range r) const
GpuMat & | setTo (Scalar s)
| sets some of the GpuMat elements to s (Blocking call) More...
GpuMat & | setTo (Scalar s, Stream &stream)
| sets some of the GpuMat elements to s (Non-Blocking call) More...
GpuMat & | setTo (Scalar s, InputArray mask)
| sets some of the GpuMat elements to s, according to the mask (Blocking call) More...
GpuMat & | setTo (Scalar s, InputArray mask, Stream &stream)
| sets some of the GpuMat elements to s, according to the mask (Non-Blocking call) More...
Size | size () const
| returns GpuMat size : width == number of columns, height == number of rows More...
size_t | step1 () const
| returns step/elemSize1() More...
void | swap (GpuMat &mat)
| swaps with other smart pointer More...
int | type () const
| returns element type More...
void | updateContinuityFlag ()
| internal use method: updates the continuity flag More...
void | upload (InputArray arr)
| Performs data upload to GpuMat (Blocking call) More...
void | upload (InputArray arr, Stream &stream)
| Performs data upload to GpuMat (Non-Blocking call) More...

## Static Public Member Functions
static Allocator * | defaultAllocator ()
| default allocator More...
static void | setDefaultAllocator (Allocator *allocator)

## Public Attributes
Allocator * | allocator
| allocator More...
int | cols
uchar * | data
| pointer to the data More...
const uchar * | dataend
uchar * | datastart
| helper fields used in locateROI and adjustROI More...
int | flags
int * | refcount
int | rows
| the number of rows and columns More...
size_t | step
| a distance between successive rows in bytes; includes the gap if any More...

## Detailed Description

Base storage class for GPU memory with reference counting.

Its interface matches the Mat interface with the following limitations:

- no arbitrary dimensions support (only 2D)
- no functions that return references to their data (because references on GPU are not valid for CPU)
- no expression templates technique support

Beware that the latter limitation may lead to overloaded matrix operators that cause memory allocations. The GpuMat class is convertible to cuda::PtrStepSz and cuda::PtrStep so it can be passed directly to the kernel.

Note
  In contrast with Mat, in most cases GpuMat::isContinuous() == false . This means that rows are aligned to a size depending on the hardware. Single-row GpuMat is always a continuous matrix.
  You are not recommended to leave static or global GpuMat variables allocated, that is, to rely on its destructor. The destruction order of such variables and CUDA context is undefined. GPU memory release function returns error if the CUDA context has been destroyed before.

Some member functions are described as a "Blocking Call" while some are described as a "Non-Blocking Call". Blocking functions are synchronous to host. It is guaranteed that the GPU operation is finished when the function returns. However, non-blocking functions are asynchronous to host. Those functions may return even if the GPU operation is not finished.

Compared to their blocking counterpart, non-blocking functions accept Stream as an additional argument. If a non-default stream is passed, the GPU operation may overlap with operations in other streams.

See also
  Mat

Examples:
  houghlines.cpp.

## Constructor & Destructor Documentation

## ◆ GpuMat() [1/11]

cv::cuda::GpuMat::GpuMat | ( | Allocator * | allocator = `defaultAllocator()` | ) |
| explicit

default constructor

## ◆ GpuMat() [2/11]

cv::cuda::GpuMat::GpuMat | ( | int | rows,
|  | int | cols,
|  | int | type,
|  | Allocator * | allocator = `defaultAllocator()`
| ) |  |

constructs GpuMat of the specified size and type

## ◆ GpuMat() [3/11]

cv::cuda::GpuMat::GpuMat | ( | Size | size,
|  | int | type,
|  | Allocator * | allocator = `defaultAllocator()`
| ) |  |

## ◆ GpuMat() [4/11]

cv::cuda::GpuMat::GpuMat | ( | int | rows,
|  | int | cols,
|  | int | type,
|  | Scalar | s,
|  | Allocator * | allocator = `defaultAllocator()`
| ) |  |

constucts GpuMat and fills it with the specified value _s

## ◆ GpuMat() [5/11]

cv::cuda::GpuMat::GpuMat | ( | Size | size,
|  | int | type,
|  | Scalar | s,
|  | Allocator * | allocator = `defaultAllocator()`
| ) |  |

## ◆ GpuMat() [6/11]

cv::cuda::GpuMat::GpuMat | ( | const GpuMat & | m | ) |

copy constructor

## ◆ GpuMat() [7/11]

cv::cuda::GpuMat::GpuMat | ( | int | rows,
|  | int | cols,
|  | int | type,
|  | void * | data,
|  | size_t | step = `Mat::AUTO_STEP`
| ) |  |

constructor for GpuMat headers pointing to user-allocated data

## ◆ GpuMat() [8/11]

cv::cuda::GpuMat::GpuMat | ( | Size | size,
|  | int | type,
|  | void * | data,
|  | size_t | step = `Mat::AUTO_STEP`
| ) |  |

## ◆ GpuMat() [9/11]

cv::cuda::GpuMat::GpuMat | ( | const GpuMat & | m,
|  | Range | rowRange,
|  | Range | colRange
| ) |  |

creates a GpuMat header for a part of the bigger matrix

## ◆ GpuMat() [10/11]

cv::cuda::GpuMat::GpuMat | ( | const GpuMat & | m,
|  | Rect | roi
| ) |  |

## ◆ GpuMat() [11/11]

cv::cuda::GpuMat::GpuMat | ( | InputArray | arr,
|  | Allocator * | allocator = `defaultAllocator()`
| ) |  |
| explicit

builds GpuMat from host memory (Blocking call)

## ◆ ~GpuMat()

cv::cuda::GpuMat::~GpuMat | ( |  | ) |

destructor - calls release()

## Member Function Documentation

## ◆ adjustROI()

GpuMat& cv::cuda::GpuMat::adjustROI | ( | int | dtop,
|  | int | dbottom,
|  | int | dleft,
|  | int | dright
| ) |  |

moves/resizes the current GpuMat ROI inside the parent GpuMat

## ◆ assignTo()

void cv::cuda::GpuMat::assignTo | ( | GpuMat & | m,
|  | int | type = `-1`
| ) |  | const

## ◆ channels()

int cv::cuda::GpuMat::channels | ( |  | ) | const

returns number of channels

## ◆ clone()

GpuMat cv::cuda::GpuMat::clone | ( |  | ) | const

returns deep copy of the GpuMat, i.e. the data is copied

## ◆ col()

GpuMat cv::cuda::GpuMat::col | ( | int | x | ) | const

returns a new GpuMat header for the specified column

## ◆ colRange() [1/2]

GpuMat cv::cuda::GpuMat::colRange | ( | int | startcol,
|  | int | endcol
| ) |  | const

... for the specified column span

## ◆ colRange() [2/2]

GpuMat cv::cuda::GpuMat::colRange | ( | Range | r | ) | const

## ◆ convertTo() [1/5]

void cv::cuda::GpuMat::convertTo | ( | OutputArray | dst,
|  | int | rtype
| ) |  | const

converts GpuMat to another datatype (Blocking call)

## ◆ convertTo() [2/5]

void cv::cuda::GpuMat::convertTo | ( | OutputArray | dst,
|  | int | rtype,
|  | Stream & | stream
| ) |  | const

converts GpuMat to another datatype (Non-Blocking call)

## ◆ convertTo() [3/5]

void cv::cuda::GpuMat::convertTo | ( | OutputArray | dst,
|  | int | rtype,
|  | double | alpha,
|  | double | beta = `0.0`
| ) |  | const

converts GpuMat to another datatype with scaling (Blocking call)

## ◆ convertTo() [4/5]

void cv::cuda::GpuMat::convertTo | ( | OutputArray | dst,
|  | int | rtype,
|  | double | alpha,
|  | Stream & | stream
| ) |  | const

converts GpuMat to another datatype with scaling (Non-Blocking call)

## ◆ convertTo() [5/5]

void cv::cuda::GpuMat::convertTo | ( | OutputArray | dst,
|  | int | rtype,
|  | double | alpha,
|  | double | beta,
|  | Stream & | stream
| ) |  | const

converts GpuMat to another datatype with scaling (Non-Blocking call)

## ◆ copyTo() [1/4]

void cv::cuda::GpuMat::copyTo | ( | OutputArray | dst | ) | const

copies the GpuMat content to device memory (Blocking call)

## ◆ copyTo() [2/4]

void cv::cuda::GpuMat::copyTo | ( | OutputArray | dst,
|  | Stream & | stream
| ) |  | const

copies the GpuMat content to device memory (Non-Blocking call)

## ◆ copyTo() [3/4]

void cv::cuda::GpuMat::copyTo | ( | OutputArray | dst,
|  | InputArray | mask
| ) |  | const

copies those GpuMat elements to "m" that are marked with non-zero mask elements (Blocking call)

## ◆ copyTo() [4/4]

void cv::cuda::GpuMat::copyTo | ( | OutputArray | dst,
|  | InputArray | mask,
|  | Stream & | stream
| ) |  | const

copies those GpuMat elements to "m" that are marked with non-zero mask elements (Non-Blocking call)

## ◆ create() [1/2]

void cv::cuda::GpuMat::create | ( | int | rows,
|  | int | cols,
|  | int | type
| ) |  |

allocates new GpuMat data unless the GpuMat already has specified size and type

## ◆ create() [2/2]

void cv::cuda::GpuMat::create | ( | Size | size,
|  | int | type
| ) |  |

## ◆ defaultAllocator()

static Allocator* cv::cuda::GpuMat::defaultAllocator | ( |  | ) |
| static

default allocator

## ◆ depth()

int cv::cuda::GpuMat::depth | ( |  | ) | const

returns element type

## ◆ download() [1/2]

void cv::cuda::GpuMat::download | ( | OutputArray | dst | ) | const

Performs data download from GpuMat (Blocking call)

This function copies data from device memory to host memory. As being a blocking call, it is guaranteed that the copy operation is finished when this function returns.

Examples:
  houghlines.cpp.

## ◆ download() [2/2]

void cv::cuda::GpuMat::download | ( | OutputArray | dst,
|  | Stream & | stream
| ) |  | const

Performs data download from GpuMat (Non-Blocking call)

This function copies data from device memory to host memory. As being a non-blocking call, this function may return even if the copy operation is not finished.

The copy operation may be overlapped with operations in other non-default streams if `stream` is not the default stream and `dst` is HostMem allocated with HostMem::PAGE_LOCKED option.

## ◆ elemSize()

size_t cv::cuda::GpuMat::elemSize | ( |  | ) | const

returns element size in bytes

## ◆ elemSize1()

size_t cv::cuda::GpuMat::elemSize1 | ( |  | ) | const

returns the size of element channel in bytes

## ◆ empty()

bool cv::cuda::GpuMat::empty | ( |  | ) | const

returns true if GpuMat data is NULL

Examples:
  houghlines.cpp.

## ◆ isContinuous()

bool cv::cuda::GpuMat::isContinuous | ( |  | ) | const

returns true iff the GpuMat data is continuous (i.e. when there are no gaps between successive rows)

## ◆ locateROI()

void cv::cuda::GpuMat::locateROI | ( | Size & | wholeSize,
|  | Point & | ofs
| ) |  | const

locates GpuMat header within a parent GpuMat

## ◆ operator PtrStep< _Tp >()

template<typename _Tp >

cv::cuda::GpuMat::operator PtrStep< _Tp > | ( |  | ) | const

## ◆ operator PtrStepSz< _Tp >()

template<typename _Tp >

cv::cuda::GpuMat::operator PtrStepSz< _Tp > | ( |  | ) | const

## ◆ operator()() [1/2]

GpuMat cv::cuda::GpuMat::operator() | ( | Range | rowRange,
|  | Range | colRange
| ) |  | const

extracts a rectangular sub-GpuMat (this is a generalized form of row, rowRange etc.)

## ◆ operator()() [2/2]

GpuMat cv::cuda::GpuMat::operator() | ( | Rect | roi | ) | const

## ◆ operator=()

GpuMat& cv::cuda::GpuMat::operator= | ( | const GpuMat & | m | ) |

assignment operators

## ◆ ptr() [1/4]

uchar* cv::cuda::GpuMat::ptr | ( | int | y = `0` | ) |

returns pointer to y-th row

## ◆ ptr() [2/4]

const uchar* cv::cuda::GpuMat::ptr | ( | int | y = `0` | ) | const

## ◆ ptr() [3/4]

template<typename _Tp >

_Tp* cv::cuda::GpuMat::ptr | ( | int | y = `0` | ) |

template version of the above method

## ◆ ptr() [4/4]

template<typename _Tp >

const _Tp* cv::cuda::GpuMat::ptr | ( | int | y = `0` | ) | const

## ◆ release()

void cv::cuda::GpuMat::release | ( |  | ) |

decreases reference counter, deallocate the data when reference counter reaches 0

## ◆ reshape()

GpuMat cv::cuda::GpuMat::reshape | ( | int | cn,
|  | int | rows = `0`
| ) |  | const

creates alternative GpuMat header for the same data, with different number of channels and/or different number of rows

## ◆ row()

GpuMat cv::cuda::GpuMat::row | ( | int | y | ) | const

returns a new GpuMat header for the specified row

## ◆ rowRange() [1/2]

GpuMat cv::cuda::GpuMat::rowRange | ( | int | startrow,
|  | int | endrow
| ) |  | const

... for the specified row span

## ◆ rowRange() [2/2]

GpuMat cv::cuda::GpuMat::rowRange | ( | Range | r | ) | const

## ◆ setDefaultAllocator()

static void cv::cuda::GpuMat::setDefaultAllocator | ( | Allocator * | allocator | ) |
| static

## ◆ setTo() [1/4]

GpuMat& cv::cuda::GpuMat::setTo | ( | Scalar | s | ) |

sets some of the GpuMat elements to s (Blocking call)

## ◆ setTo() [2/4]

GpuMat& cv::cuda::GpuMat::setTo | ( | Scalar | s,
|  | Stream & | stream
| ) |  |

sets some of the GpuMat elements to s (Non-Blocking call)

## ◆ setTo() [3/4]

GpuMat& cv::cuda::GpuMat::setTo | ( | Scalar | s,
|  | InputArray | mask
| ) |  |

sets some of the GpuMat elements to s, according to the mask (Blocking call)

## ◆ setTo() [4/4]

GpuMat& cv::cuda::GpuMat::setTo | ( | Scalar | s,
|  | InputArray | mask,
|  | Stream & | stream
| ) |  |

sets some of the GpuMat elements to s, according to the mask (Non-Blocking call)

## ◆ size()

Size cv::cuda::GpuMat::size | ( |  | ) | const

returns GpuMat size : width == number of columns, height == number of rows

## ◆ step1()

size_t cv::cuda::GpuMat::step1 | ( |  | ) | const

returns step/elemSize1()

## ◆ swap()

void cv::cuda::GpuMat::swap | ( | GpuMat & | mat | ) |

swaps with other smart pointer

## ◆ type()

int cv::cuda::GpuMat::type | ( |  | ) | const

returns element type

## ◆ updateContinuityFlag()

void cv::cuda::GpuMat::updateContinuityFlag | ( |  | ) |

internal use method: updates the continuity flag

## ◆ upload() [1/2]

void cv::cuda::GpuMat::upload | ( | InputArray | arr | ) |

Performs data upload to GpuMat (Blocking call)

This function copies data from host memory to device memory. As being a blocking call, it is guaranteed that the copy operation is finished when this function returns.

## ◆ upload() [2/2]

void cv::cuda::GpuMat::upload | ( | InputArray | arr,
|  | Stream & | stream
| ) |  |

Performs data upload to GpuMat (Non-Blocking call)

This function copies data from host memory to device memory. As being a non-blocking call, this function may return even if the copy operation is not finished.

The copy operation may be overlapped with operations in other non-default streams if `stream` is not the default stream and `dst` is HostMem allocated with HostMem::PAGE_LOCKED option.

## Member Data Documentation

## ◆ allocator

Allocator* cv::cuda::GpuMat::allocator

allocator

## ◆ cols

int cv::cuda::GpuMat::cols

Examples:
  houghlines.cpp.

## ◆ data

uchar* cv::cuda::GpuMat::data

pointer to the data

## ◆ dataend

const uchar* cv::cuda::GpuMat::dataend

## ◆ datastart

uchar* cv::cuda::GpuMat::datastart

helper fields used in locateROI and adjustROI

## ◆ flags

int cv::cuda::GpuMat::flags

includes several bit-fields:

- the magic signature
- continuity flag
- depth
- number of channels

## ◆ refcount

int* cv::cuda::GpuMat::refcount

pointer to the reference counter; when GpuMat points to user-allocated data, the pointer is NULL

## ◆ rows

int cv::cuda::GpuMat::rows

the number of rows and columns

## ◆ step

size_t cv::cuda::GpuMat::step

a distance between successive rows in bytes; includes the gap if any

The documentation for this class was generated from the following file:

- core/include/opencv2/core/cuda.hpp